import { Factory, CssKnownProps, CssRule, CssVars } from '@cssfn/core';
export interface CheckableVars {
    filterIn: any;
    filterOut: any;
    transformIn: any;
    transformOut: any;
    /**
     * final filter for the check indicator element.
     */
    filter: any;
    /**
     * final transform for the check indicator element.
     */
    transform: any;
    /**
     * final animation for the check indicator element.
     */
    anim: any;
}
export interface CheckableStuff {
    checkableRule: Factory<CssRule>;
    checkableVars: CssVars<CheckableVars>;
}
export interface CheckableConfig {
    checkFilterIn?: CssKnownProps['filter'];
    checkFilterOut?: CssKnownProps['filter'];
    checkTransformIn?: CssKnownProps['transform'];
    checkTransformOut?: CssKnownProps['transform'];
    checkAnimIn?: CssKnownProps['animation'];
    checkAnimOut?: CssKnownProps['animation'];
}
/**
 * Adds a capability of UI to be checked.
 * @param config  A configuration of `checkableRule`.
 * @returns A `CheckableStuff` represents a checkable state.
 */
export declare const usesCheckable: (config?: CheckableConfig) => CheckableStuff;
